#include <stdio.h>
#include <string.h>
#include <sys/select.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>

#define TRUE (1)
#define FALSE (0)

#define BUF_SIZE 80

void showUsage() {
	fprintf(stderr, "Usage: rfk-smtpd <command> [<command-args>]*\n");
}

int process(char *buf, char *tmp) {
	if (strncmp(buf, "rcpt", 4) == 0) {
		strcpy(tmp, "553 Recipient is unknown.\r\n");
		return FALSE;
	}
	return TRUE;
}

int doIt(char* prog) {
	FILE *smtpd;
	char buf[BUF_SIZE + 1];
	fd_set fds;
	int go = TRUE;
	int error = FALSE;

	smtpd = popen(prog, "r+");
	if (smtpd == NULL) {
		fprintf(stderr, "Cannot create process '%s'\n", prog);
		return FALSE;
	}
	while(go) {
		FD_ZERO(&fds);
		FD_SET(fileno(stdin), &fds);
		FD_SET(fileno(smtpd), &fds);
		int res = select(FD_SETSIZE, &fds, NULL, NULL, NULL);
		if (res == -1) {
			fprintf(stderr, "Select: error.\n");
			error = TRUE;
			go = FALSE;
		}
		if (res == 0) {
			fprintf(stderr, "Select: timeout.\n");
		}
		while(!error && res--) {
			size_t nr;
			if (FD_ISSET(fileno(stdin), &fds)) {
				nr = read(fileno(stdin), buf, BUF_SIZE);
				if (nr <= 0) {
					error = TRUE;
					go = FALSE;
				} else {
					char tmp[BUF_SIZE + 1];
					int ok;
					buf[nr] = '\0';
					ok = process(buf, tmp);
					if (ok) {
						fprintf(smtpd, "%s", buf);
						fflush(smtpd);
					} else {
						fprintf(stdout, "%s", tmp);
						fflush(stdout);
					}
				}
			}
			if (FD_ISSET(fileno(smtpd), &fds)) {
				nr = read(fileno(smtpd), buf, BUF_SIZE);
				if (nr <= 0) {
					error = TRUE;
					go = FALSE;
				} else {
					buf[nr] = '\0';
					fprintf(stdout, "%s", buf);
					fflush(stdout);
				}
			}
		}
	}
	pclose(smtpd);
	return !error;
}

int main(int argc, char **argv) {
	char prog[1024];
	int error;
	int i, ind;

	if (argc < 2) {
		showUsage();
		return 1;
	}
	ind = 0;
	strcpy(&prog[ind], argv[1]);
	ind = strlen(argv[1]);
	for(i = 2; i < argc; i++) {
		prog[ind++] = ' ';
		strcpy(&prog[ind], argv[i]);
		ind += strlen(argv[i]);
	}

	error = !doIt(prog);

	return error;
}

